package com.rrr.iidtest;

import java.util.List;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.ui.ApplicationFrame;
import org.jfree.data.category.DefaultCategoryDataset;

public class LineChart_AWT extends ApplicationFrame {

    private static final long serialVersionUID = 06445011L;

    private LineChart_AWT(List<Integer> statistics, int Ti) {
        super("IID Test Results");
        JFreeChart lineChart = ChartFactory.createLineChart(
                "",
                "Ordered #permutation", "Normalised test statistic",
                createDataset(statistics, Ti),
                PlotOrientation.VERTICAL,
                false, true, false);

        CategoryPlot plot = (CategoryPlot) lineChart.getPlot();
        NumberAxis axis = (NumberAxis) plot.getRangeAxis();
        axis.setAutoRangeIncludesZero(false);
        ChartPanel chartPanel = new ChartPanel(lineChart);
        chartPanel.setPreferredSize(new java.awt.Dimension(640, 480));
        setContentPane(chartPanel);
    }

    private DefaultCategoryDataset createDataset(List<Integer> statistics, int Ti) {
        DefaultCategoryDataset dataset = new DefaultCategoryDataset();
        statistics.forEach((T) -> {
            double s = (double) T / Ti;
            dataset.addValue(s, "statistic", String.valueOf(T));
        });
        return dataset;
    }

    public static void plot(List<Integer> statistics, int Ti) {
        LineChart_AWT chart = new LineChart_AWT(statistics, Ti);
        chart.pack();
        chart.setVisible(true);
    }
}
